The OpenNET Project / Index page

[ новости /+++ | форум | wiki | теги | ]

форумы  помощь  поиск  регистрация  майллист  вход/выход  слежка  RSS
"Новая критическая уязвимость в GraphicsMagick и ImageMagick"
Вариант для распечатки  
Пред. тема | След. тема 
Форум Разговоры, обсуждение новостей
Изначальное сообщение [ Отслеживать ]

"Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от opennews (ok) on 30-Май-16, 10:39 
В пакетах ImageMagick (http://www.imagemagick.org/) и GraphicsMagick (http://www.graphicsmagick.org/) выявлена ещё одна опасная уязвимость (http://seclists.org/oss-sec/2016/q2/432) (CVE-2016-5118), позволяющая выполнить произвольные команды shell при обработке специально оформленного имени файла. Проблема связана с передачей в вызов popen имени файла, без его проверки на наличие спецсимволов, что позволяет использовать модификатор "|", отвечающий за  ответвление процесса для создания канала ввода-вода. Передав вместо имени файла аргумент "|имя" можно выполнить произвольный код, например:


<font color="#461b7e">
   convert '|echo Hello > hello.txt;' null:
</font>

Кроме эксплуатации приложений,  для преобразования форматов изображений вызывающих утилиту convert, атака может быть проведена при обработке специально оформленных SVG- или MVG-файлов, в которых вместо ссылки на изображение может применяться конструкция:

<font color="#461b7e">

SVG:

   xlink:href="|echo Hello > hello.txt; cat /usr/lib/firefox/browser/icons/mozicon128.png"

MVG:

  push graphic-context
  viewbox 0 0 640 480
  image copy 200,200 100,100 "|echo Hello > hello.txt; cat /usr/lib/firefox/browser/icons/mozicon128.png"
  pop graphic-context

</font>

Проблема присутствует в функции OpenBlob() из состава blob.c. Не исключено, что кроме утилиты convert и обработчиков SVG/MVG, уязвимость может проявляться и в других областях применения GraphicsMagick и ImageMagick. В качестве решения проблемы рекомендуется отключить использование функции popen, убрав флаг HAVE_POPEN в файле magick/blob.c ("#undef HAVE_POPEN"). На момент написания новости исправление доступно лишь в виде патча (http://seclists.org/oss-sec/2016/q2/att-432/disable-popen-fi...). Обновления пакетов для дистрибутивов еще не сформированы: Debian (https://security-tracker.debian.org/tracker/CVE-2016-5118), Ubuntu (https://people.canonical.com/~ubuntu-security/cve/2016/CVE-2...), RHEL/CentOS (https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2016-5118), SUSE (https://bugzilla.novell.com/show_bug.cgi?id=CVE-2016-5118), openSUSE (https://lists.opensuse.org/opensuse-security-announce/2016-05/), FreeBSD (http://www.vuxml.org/freebsd/), Fedora (https://bodhi.fedoraproject.org/updates/?releases=F23&type=s...).

URL: http://seclists.org/oss-sec/2016/q2/432
Новость: https://www.opennet.ru/opennews/art.shtml?num=44511

Ответить | Правка | Cообщить модератору

Оглавление

Сообщения по теме [Сортировка по ответам | RSS]

1. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +4 +/
Сообщение от Какаянахренразница (ok) on 30-Май-16, 10:39 
Вот жеж зараза...
Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

3. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +42 +/
Сообщение от Аноним (??) on 30-Май-16, 10:53 
Никогда такого не было, и вот опять
Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

6. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +5 +/
Сообщение от омномнимус (ok) on 30-Май-16, 11:17 
> popen имени файла, без его проверки на наличие спецсимволов

говнокод, как он есть.

Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

7. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  –5 +/
Сообщение от Андрей (??) on 30-Май-16, 11:23 
От этих пакетов никто особенно не зависит:

$ pactree -r -d 5 graphicsmagick
graphicsmagick
└─pdf2djvu
$ pactree -r -d 5 imagemagick
imagemagick
├─cups-filters
│ └─cups
│   └─cups-pdf
├─emacs
├─inkscape
└─pstoedit
  └─calligra-karbon

Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

8. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  –1 +/
Сообщение от Сергей (??) on 30-Май-16, 11:26 
С другой стороны, подобная уязвимость может существовать и в других пакетах...
Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

9. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +4 +/
Сообщение от й on 30-Май-16, 11:48 
на вашем локалхосте -- возможно.

imagemagick активно используют веб-приложения, тот же redmine.

Ответить | Правка | ^ к родителю #7 | Наверх | Cообщить модератору

10. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  –1 +/
Сообщение от Аноним (??) on 30-Май-16, 11:56 
В redmine недели две назад добавили дополнительную защиту: https://github.com/redmine/redmine/commit/bf81c96b79cc80bc4f...
Ответить | Правка | ^ к родителю #9 | Наверх | Cообщить модератору

11. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +11 +/
Сообщение от Какаянахренразница (ok) on 30-Май-16, 12:18 
> С другой стороны, подобная уязвимость может существовать и в других пакетах...

Избушка-избушка, повернись к лесу передом, ко мне задом. Возможно, с другой стороны у тебя существует уязвимость.

Ответить | Правка | ^ к родителю #8 | Наверх | Cообщить модератору

12. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +5 +/
Сообщение от Аноним (??) on 30-Май-16, 12:19 
Сервера активно используют их для конвертации, ресайза, обрезки и т.д. картинок, в том числе на лету.
Ответить | Правка | ^ к родителю #7 | Наверх | Cообщить модератору

13. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от Аноним (??) on 30-Май-16, 12:21 
Старый workaround подходит ( https://slashdot.org/comments.pl?sid=9074795&cid=52061711 ), как я полагаю.

// b.

Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

14. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +2 +/
Сообщение от Какаянахренразница (ok) on 30-Май-16, 12:26 
> От этих пакетов никто особенно не зависит:

php5-imagick зависит. А он на многих веб-серверах используется.

Ответить | Правка | ^ к родителю #7 | Наверх | Cообщить модератору

15. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от й on 30-Май-16, 13:03 
и как она защитит от malformed svg, как в новости?
Ответить | Правка | ^ к родителю #10 | Наверх | Cообщить модератору

16. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от тоже Аноним email(ok) on 30-Май-16, 13:07 
А, собственно, какая из этих строчек прикроет дырку в SVG?
Ответить | Правка | ^ к родителю #13 | Наверх | Cообщить модератору

17. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +1 +/
Сообщение от Аноним (??) on 30-Май-16, 13:41 
Критическая статья бывает, а уязвимость критичная
Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

18. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от Аноним (??) on 30-Май-16, 13:46 
...и этот патч делает #undef HAVE_POPEN? Да уж, исправление так исправление.
Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

19. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от Аноним (??) on 30-Май-16, 13:46 
<policy domain="coder" rights="none" pattern="URL" />
Ответить | Правка | ^ к родителю #16 | Наверх | Cообщить модератору

20. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +2 +/
Сообщение от Аноним (??) on 30-Май-16, 15:07 
Ежели хотел ум свой показать, так у тебя не вышло: под новостью кнопка "исправить" есть. Специально для таких случаев, прикинь?
Ответить | Правка | ^ к родителю #17 | Наверх | Cообщить модератору

21. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +1 +/
Сообщение от chinarulezzz (ok) on 30-Май-16, 15:23 

┌─[ ~ ]
└─$ gm convert '|echo Hello > hello.txt;' null:
gm convert: Unable to open file (/tmp/gmszBE6e) [Нет такого файла или каталога].

Что не так?!

Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

22. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от Аноним (??) on 30-Май-16, 15:43 
Меня тоже держите в курсе :D

$ convert '|echo Hello > hello.txt;' null:
convert: no decode delegate for this image format `TXT;' @ error/constitute.c/ReadImage/501.
convert: no images defined `null:' @ error/convert.c/ConvertImageCommand/3210.

Debian GNU/Linux 8.4 (jessie)

$ convert --version
Version: ImageMagick 6.8.9-9 Q16 x86_64 2016-05-16

Ответить | Правка | ^ к родителю #21 | Наверх | Cообщить модератору

23. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  –1 +/
Сообщение от омномнимус (ok) on 30-Май-16, 15:46 

$ convert '|echo Hello > hello.txt;' null:
convert.im6: no decode delegate for this image format `/tmp/magick-cAeKOHK7' @ error/constitute.c/ReadImage/544.
convert.im6: no images defined `null:' @ error/convert.c/ConvertImageCommand/3044.
$ cat hello.txt
Hello
$ convert -version
Version: ImageMagick 6.7.7-10 2014-03-06 Q16 http://www.imagemagick.org
Copyright: Copyright (C) 1999-2012 ImageMagick Studio LLC
Features: OpenMP    

Ответить | Правка | ^ к родителю #21 | Наверх | Cообщить модератору

24. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от chinarulezzz (ok) on 30-Май-16, 15:50 
> Меня тоже держите в курсе :D

ааа, тупанул) проверил hello.txt, всё как и ожидалось.

Ответить | Правка | ^ к родителю #22 | Наверх | Cообщить модератору

25. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от Аноним (??) on 30-Май-16, 15:50 
$ cat hello.txt
cat: hello.txt: Нет такого файла или каталога

ЧЯДНТ?

Ответить | Правка | ^ к родителю #23 | Наверх | Cообщить модератору

26. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  –1 +/
Сообщение от Нанобот (ok) on 30-Май-16, 15:52 
>Что не так?!

всё так, файл hello.txt создаётся

Ответить | Правка | ^ к родителю #21 | Наверх | Cообщить модератору

27. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от омномнимус (ok) on 30-Май-16, 16:16 
телепаты в отпуске
Ответить | Правка | ^ к родителю #25 | Наверх | Cообщить модератору

28. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +1 +/
Сообщение от Кто тут on 31-Май-16, 08:51 
Выводится ошибка, но файл создается. Установил mc через imagemagic. Полет нормальный.
Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

29. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  –1 +/
Сообщение от Аноним (??) on 31-Май-16, 09:17 
«... в вызов popen...» — главное, дальше можно не читать. Интересно, Тео же Раадт и компания рискнут убрать popen из libc?..
Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

30. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  –1 +/
Сообщение от Stellarwind on 31-Май-16, 12:17 
Точно те же самые проблемы уже давным давно находили вроде в mplayer/mencoder, но авторы упорно продолжают ходить по граблям. Только там еще с плейлистами проблемы были.
Ответить | Правка | ^ к родителю #3 | Наверх | Cообщить модератору

31. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от Аноним (??) on 31-Май-16, 18:16 
На одном известном порносайте-галерее с самописным движком через предыдущую дыру в ImageMagic украли исходный код движка и базу пользователей с хешами паролей. Через имя файла тоже можно запустить tar+xz+curl, чтобы упаковать всё интересное и загрузить на сервер злоумышленника.
Ответить | Правка | ^ к родителю #7 | Наверх | Cообщить модератору

32. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от Alexey G email on 31-Май-16, 21:40 
http://git.imagemagick.org/repos/ImageMagick/commit/ca430ff7...
Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

33. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от Led (ok) on 31-Май-16, 22:23 
> Интересно, Тео же Раадт и компания рискнут убрать popen из libc?..

Пусть они сначала сами вылезут из popen.


Ответить | Правка | ^ к родителю #29 | Наверх | Cообщить модератору

35. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  –1 +/
Сообщение от ano (??) on 01-Июн-16, 23:18 
больше уязвимостей, хороших и разных
Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору

36. "Новая критическая уязвимость в GraphicsMagick и ImageMagick"  +/
Сообщение от Аноним (??) on 02-Июн-16, 02:05 
такая конструкция хорошо работает: convert '|echo Hello > hello.txt;' null:

А как создать SVG файл? Что-то не получается

Ответить | Правка | ^ к родителю #0 | Наверх | Cообщить модератору


Архив | Удалить

Рекомендовать для помещения в FAQ | Индекс форумов | Темы | Пред. тема | След. тема




Спонсоры:
Inferno Solutions
Hosting by Hoster.ru
Хостинг:

Закладки на сайте
Проследить за страницей
Created 1996-2021 by Maxim Chirkov
Добавить, Поддержать, Вебмастеру